
cd('c:/dobbs').

[convert_life_pattern].

convert_life_pattern('pulsar.dots',pulsar).

line_to_equations( "..**..*", pat, 4,4, Eqns ).

line_to_equations( "..**..*", pat, 1,3, Eqns ).

line_to_equations( "..**..*", pat, 0,0, Eqns ).

line_to_equations( "*.*", pat, 0,0, Eqns ).

line_to_equations( "", pat, 0,0, Eqns ).

line_to_equations( [], pat, 0,0, Eqns ).

line_to_equations( [ 0'*, 0'., 0'* ], pat, 0,0, Eqns ).

write_equation( eqn(pulsar,0,1) ).

write_equation( eqn(glider,3,2) ).

maplist( write_equation, [eqn(pulsar,0,1)] ).

maplist( write_equation, [eqn(pulsar,0,1),eqn(pulsar,2,3)] ).

maplist( write_equation, [] ).

line_to_equations( [42,46,42], pat, 0,0, Eqns ).

line_to_equations( "****", pat, 0,0, Eqns ).

[convert_life_pattern_2].

line_to_equations( "****", pat, 0,0, Eqns ).

write( go(belgium,france) ).

write( eqn(pat,0,0) ).

write( u+v ).

write( 1+2 ).

write( +(1,2) ).

keysort( [ 8-a, 7-x, 3-foo, 2-fred, 4-go(belgium,france), 9-(1+2), 0-eqn(pat,0,0) ], Sorted ).

flatten( [], F ).

flatten( [ [1],2,[3] ], F ).

flatten( [ [[[[1]]]],[[[2,[3]]]] ], F ).

atom_concat( a, b, A ).

atom_concat( pulsar, '.exc', A ).

atom_concat( 'pulsar', '.exc', A ).

tell(myfile), write('Line 1.\n'), format( 'Line ~w.~n', [2] ), told.

read_file_to_lines( 'pulsar.dots', Lines ).

open( 'pulsar.dots', read, Stream, [] ), read_line_to_codes( Stream, Line ).

open( 'empty.dots', read, Stream, [] ), read_line_to_codes( Stream, Line ).

